# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.active_frequency_band import ActiveFrequencyBand  # noqa: F401,E501
from swagger_server.models.gnb_descriptor import GnbDescriptor  # noqa: F401,E501
from swagger_server.models.ransim_metrics import RansimMetrics  # noqa: F401,E501
from swagger_server.models.resource_configuration import ResourceConfiguration  # noqa: F401,E501
from swagger_server import util


class StartSimulationInput(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, metrics_to_monitor: List[RansimMetrics]=None, topic_name: str=None, initial_resource_configuration: ResourceConfiguration=None, gnb_list: List[GnbDescriptor]=None, afb_list: List[ActiveFrequencyBand]=None, traffic_profile_cardinality: int=None):  # noqa: E501
        """StartSimulationInput - a model defined in Swagger

        :param metrics_to_monitor: The metrics_to_monitor of this StartSimulationInput.  # noqa: E501
        :type metrics_to_monitor: List[RansimMetrics]
        :param topic_name: The topic_name of this StartSimulationInput.  # noqa: E501
        :type topic_name: str
        :param initial_resource_configuration: The initial_resource_configuration of this StartSimulationInput.  # noqa: E501
        :type initial_resource_configuration: ResourceConfiguration
        :param gnb_list: The gnb_list of this StartSimulationInput.  # noqa: E501
        :type gnb_list: List[GnbDescriptor]
        :param afb_list: The afb_list of this StartSimulationInput.  # noqa: E501
        :type afb_list: List[ActiveFrequencyBand]
        :param traffic_profile_cardinality: The traffic_profile_cardinality of this StartSimulationInput.  # noqa: E501
        :type traffic_profile_cardinality: int
        """
        self.swagger_types = {
            'metrics_to_monitor': List[RansimMetrics],
            'topic_name': str,
            'initial_resource_configuration': ResourceConfiguration,
            'gnb_list': List[GnbDescriptor],
            'afb_list': List[ActiveFrequencyBand],
            'traffic_profile_cardinality': int
        }

        self.attribute_map = {
            'metrics_to_monitor': 'metrics-to-monitor',
            'topic_name': 'topic-name',
            'initial_resource_configuration': 'initial-resource-configuration',
            'gnb_list': 'gnb-list',
            'afb_list': 'afb-list',
            'traffic_profile_cardinality': 'traffic-profile-cardinality'
        }
        self._metrics_to_monitor = metrics_to_monitor
        self._topic_name = topic_name
        self._initial_resource_configuration = initial_resource_configuration
        self._gnb_list = gnb_list
        self._afb_list = afb_list
        self._traffic_profile_cardinality = traffic_profile_cardinality

    @classmethod
    def from_dict(cls, dikt) -> 'StartSimulationInput':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The start-simulation-input of this StartSimulationInput.  # noqa: E501
        :rtype: StartSimulationInput
        """
        return util.deserialize_model(dikt, cls)

    @property
    def metrics_to_monitor(self) -> List[RansimMetrics]:
        """Gets the metrics_to_monitor of this StartSimulationInput.

        List of the metrics to be retrieved for this datasource.  # noqa: E501

        :return: The metrics_to_monitor of this StartSimulationInput.
        :rtype: List[RansimMetrics]
        """
        return self._metrics_to_monitor

    @metrics_to_monitor.setter
    def metrics_to_monitor(self, metrics_to_monitor: List[RansimMetrics]):
        """Sets the metrics_to_monitor of this StartSimulationInput.

        List of the metrics to be retrieved for this datasource.  # noqa: E501

        :param metrics_to_monitor: The metrics_to_monitor of this StartSimulationInput.
        :type metrics_to_monitor: List[RansimMetrics]
        """

        self._metrics_to_monitor = metrics_to_monitor

    @property
    def topic_name(self) -> str:
        """Gets the topic_name of this StartSimulationInput.

        Name of the Kafka topic in which the metrics will be published  # noqa: E501

        :return: The topic_name of this StartSimulationInput.
        :rtype: str
        """
        return self._topic_name

    @topic_name.setter
    def topic_name(self, topic_name: str):
        """Sets the topic_name of this StartSimulationInput.

        Name of the Kafka topic in which the metrics will be published  # noqa: E501

        :param topic_name: The topic_name of this StartSimulationInput.
        :type topic_name: str
        """

        self._topic_name = topic_name

    @property
    def initial_resource_configuration(self) -> ResourceConfiguration:
        """Gets the initial_resource_configuration of this StartSimulationInput.


        :return: The initial_resource_configuration of this StartSimulationInput.
        :rtype: ResourceConfiguration
        """
        return self._initial_resource_configuration

    @initial_resource_configuration.setter
    def initial_resource_configuration(self, initial_resource_configuration: ResourceConfiguration):
        """Sets the initial_resource_configuration of this StartSimulationInput.


        :param initial_resource_configuration: The initial_resource_configuration of this StartSimulationInput.
        :type initial_resource_configuration: ResourceConfiguration
        """

        self._initial_resource_configuration = initial_resource_configuration

    @property
    def gnb_list(self) -> List[GnbDescriptor]:
        """Gets the gnb_list of this StartSimulationInput.

        Property to describe the gNBs involved during the simulation (useful to write the \"TLE_Nanosat_x\" files and the \"numgNB\" property inside the \"networkConfiguration_x\" file)  # noqa: E501

        :return: The gnb_list of this StartSimulationInput.
        :rtype: List[GnbDescriptor]
        """
        return self._gnb_list

    @gnb_list.setter
    def gnb_list(self, gnb_list: List[GnbDescriptor]):
        """Sets the gnb_list of this StartSimulationInput.

        Property to describe the gNBs involved during the simulation (useful to write the \"TLE_Nanosat_x\" files and the \"numgNB\" property inside the \"networkConfiguration_x\" file)  # noqa: E501

        :param gnb_list: The gnb_list of this StartSimulationInput.
        :type gnb_list: List[GnbDescriptor]
        """

        self._gnb_list = gnb_list

    @property
    def afb_list(self) -> List[ActiveFrequencyBand]:
        """Gets the afb_list of this StartSimulationInput.

        Property to describe the spectrum of each gNB (assumed so far equal for all gNBs).  # noqa: E501

        :return: The afb_list of this StartSimulationInput.
        :rtype: List[ActiveFrequencyBand]
        """
        return self._afb_list

    @afb_list.setter
    def afb_list(self, afb_list: List[ActiveFrequencyBand]):
        """Sets the afb_list of this StartSimulationInput.

        Property to describe the spectrum of each gNB (assumed so far equal for all gNBs).  # noqa: E501

        :param afb_list: The afb_list of this StartSimulationInput.
        :type afb_list: List[ActiveFrequencyBand]
        """

        self._afb_list = afb_list

    @property
    def traffic_profile_cardinality(self) -> int:
        """Gets the traffic_profile_cardinality of this StartSimulationInput.

        Property to indicate the number of possible traffic profiles that UE can use  # noqa: E501

        :return: The traffic_profile_cardinality of this StartSimulationInput.
        :rtype: int
        """
        return self._traffic_profile_cardinality

    @traffic_profile_cardinality.setter
    def traffic_profile_cardinality(self, traffic_profile_cardinality: int):
        """Sets the traffic_profile_cardinality of this StartSimulationInput.

        Property to indicate the number of possible traffic profiles that UE can use  # noqa: E501

        :param traffic_profile_cardinality: The traffic_profile_cardinality of this StartSimulationInput.
        :type traffic_profile_cardinality: int
        """

        self._traffic_profile_cardinality = traffic_profile_cardinality
